source: common/func_validate_configs.sh@ b0dd4bd

1.0 2.3 2.3.x 2.4 ablfs ablfs-more legacy new_features trunk
Last change on this file since b0dd4bd was b0dd4bd, checked in by George Boudreau <georgeb@…>, 18 years ago

Adjusted files to reflect the removal of sparcv8 identifier from the CLFS book

  • Property mode set to 100644
File size: 9.5 KB
Line 
1# $Id$
2
3validate_target() {
4
5 local -r ERROR_MSG_pt1='The variable \"${L_arrow}TARGET${R_arrow}\" value ${L_arrow}${BOLD}${TARGET}${R_arrow} is invalid for the ${L_arrow}${BOLD}${ARCH}${R_arrow} architecture'
6 local -r ERROR_MSG_pt2=' check the config file ${BOLD}${GREEN}\<$(echo $PROGNAME | tr [a-z] [A-Z])/config\> or \<common/config\>${OFF}'
7
8 local -r PARAM_VALS='TARGET: ${L_arrow}${BOLD}${TARGET}${OFF}${R_arrow}'
9 local -r PARAM_VALS2='TARGET32: ${L_arrow}${BOLD}${TARGET32}${OFF}${R_arrow}'
10
11 write_error_and_die() {
12 echo -e "\n${DD_BORDER}"
13 echo -e "`eval echo ${ERROR_MSG_pt1}`" >&2
14 echo -e "`eval echo ${ERROR_MSG_pt2}`" >&2
15 echo -e "${DD_BORDER}\n"
16 exit 1
17 }
18
19 if [[ ! "${TARGET32}" = "" ]]; then
20 echo -e "`eval echo $PARAM_VALS2`"
21 fi
22 echo -e "`eval echo $PARAM_VALS`"
23
24 case "${ARCH}" in
25 "x86") [[ "${TARGET}" = "i486-pc-linux-gnu" ]] && return
26 [[ "${TARGET}" = "i586-pc-linux-gnu" ]] && return
27 [[ "${TARGET}" = "i686-pc-linux-gnu" ]] && return
28 ;;
29 "ppc") [[ "${TARGET}" = "powerpc-unknown-linux-gnu" ]] && return
30 ;;
31 "mips") [[ "${TARGET}" = "mipsel-unknown-linux-gnu" ]] && return
32 [[ "${TARGET}" = "mips-unknown-linux-gnu" ]] && return
33 ;;
34 "sparc") [[ "${TARGET}" = "sparcv9-unknown-linux-gnu" ]] && return
35 ;;
36 "x86_64-64") [[ "${TARGET}" = "x86_64-unknown-linux-gnu" ]] && return
37 ;;
38 "mips64-64") [[ "${TARGET}" = "mipsel-unknown-linux-gnu" ]] && return
39 [[ "${TARGET}" = "mips-unknown-linux-gnu" ]] && return
40 ;;
41 "sparc64-64") [[ "${TARGET}" = "sparc64-unknown-linux-gnu" ]] && return
42 ;;
43 "alpha") [[ "${TARGET}" = "alpha-unknown-linux-gnu" ]] && return
44 ;;
45 "x86_64") [[ "${TARGET}" = "x86_64-unknown-linux-gnu" ]] &&
46 [[ "${TARGET32}" = "i686-pc-linux-gnu" ]] && return
47 ;;
48 "mips64") [[ "${TARGET}" = "mipsel-unknown-linux-gnu" ]] &&
49 [[ "${TARGET32}" = "mipsel-unknown-linux-gnu" ]] && return
50
51 [[ "${TARGET}" = "mips-unknown-linux-gnu" ]] &&
52 [[ "${TARGET32}" = "mips-unknown-linux-gnu" ]] && return
53 ;;
54 "sparc64") [[ "${TARGET}" = "sparc64-unknown-linux-gnu" ]] &&
55 [[ "${TARGET32}" = "sparcv9-unknown-linux-gnu" ]] && return
56 ;;
57 "ppc64") [[ "${TARGET}" = "powerpc64-unknown-linux-gnu" ]] &&
58 [[ "${TARGET32}" = "powerpc-unknown-linux-gnu" ]] && return
59 ;;
60 *) write_error_and_die
61 ;;
62 esac
63
64 # If you end up here then there was an error SO...
65 write_error_and_die
66}
67
68
69#----------------------------#
70validate_config() { # Are the config values sane (within reason)
71#----------------------------#
72: <<inline_doc
73 Validates the configuration parameters. The global var PROGNAME selects the
74 parameter list.
75
76 input vars: none
77 externals: color constants
78 PROGNAME (lfs,clfs,hlfs,blfs)
79 modifies: none
80 returns: nothing
81 on error: write text to console and dies
82 on success: write text to console and returns
83inline_doc
84
85 # First internal variables, then the ones that change the book's flavour, and lastly system configuration variables
86 local -r blfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE HPKG DEPEND TEST"
87 local -r hlfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE HPKG RUNMAKE MODEL GRSECURITY_HOST TEST STRIP FSTAB CONFIG KEYMAP PAGE TIMEZONE LANG LC_ALL"
88 local -r clfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE HPKG RUNMAKE METHOD ARCH TARGET TEST STRIP FSTAB BOOT_CONFIG CONFIG KEYMAP VIMLANG PAGE TIMEZONE LANG"
89 local -r lfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE HPKG RUNMAKE TEST STRIP FSTAB CONFIG VIMLANG PAGE TIMEZONE LANG"
90
91 local -r ERROR_MSG_pt1='The variable \"${L_arrow}${config_param}${R_arrow}\" value ${L_arrow}${BOLD}${!config_param}${R_arrow} is invalid,'
92 local -r ERROR_MSG_pt2=' check the config file ${BOLD}${GREEN}\<$(echo $PROGNAME | tr [a-z] [A-Z])/config\> or \<common/config\>${OFF}'
93 local -r PARAM_VALS='${config_param}: ${L_arrow}${BOLD}${!config_param}${OFF}${R_arrow}'
94
95 local PARAM_LIST=
96
97 local config_param
98 local validation_str
99
100 write_error_and_die() {
101 echo -e "\n${DD_BORDER}"
102 echo -e "`eval echo ${ERROR_MSG_pt1}`" >&2
103 echo -e "`eval echo ${ERROR_MSG_pt2}`" >&2
104 echo -e "${DD_BORDER}\n"
105 exit 1
106 }
107
108 validate_str() {
109 # This is the 'regexp' test available in bash-3.0..
110 # using it as a poor man's test for substring
111 echo -e "`eval echo $PARAM_VALS`"
112 if [[ ! "${validation_str}" =~ "x${!config_param}x" ]] ; then
113 # parameter value entered is no good
114 write_error_and_die
115 fi
116 }
117
118 set +e
119 for PARAM_GROUP in ${PROGNAME}_PARAM_LIST; do
120 for config_param in ${!PARAM_GROUP}; do
121 # This is a tricky little piece of code.. executes a cmd string.
122 case $config_param in
123 BUILDDIR) # We cannot have an <empty> or </> root mount point
124 echo -e "`eval echo $PARAM_VALS`"
125 if [[ "xx x/x" =~ "x${!config_param}x" ]]; then
126 write_error_and_die
127 fi
128 continue ;;
129 TIMEZONE) continue;;
130 MKFILE) continue;;
131 HPKG) validation_str="x0x x1x"; validate_str; continue ;;
132 RUNMAKE) validation_str="x0x x1x"; validate_str; continue ;;
133 TEST) validation_str="x0x x1x x2x x3x"; validate_str; continue ;;
134 STRIP) validation_str="x0x x1x"; validate_str; continue ;;
135 VIMLANG) validation_str="x0x x1x"; validate_str; continue ;;
136 DEPEND) validation_str="x0x x1x x2x"; validate_str; continue ;;
137 MODEL) validation_str="xglibcx xuclibcx"; validate_str; continue ;;
138 PAGE) validation_str="xletterx xA4x"; validate_str; continue ;;
139 GRSECURITY_HOST) validation_str="x0x x1x"; validate_str; continue ;;
140 METHOD) validation_str="xchrootx xbootx"; validate_str; continue ;;
141 ARCH) validation_str="xx86x xx86_64x xx86_64-64x xsparcx xsparc64x xsparc64-64x xmipsx xmips64x xmips64-64x xppcx xppc64x xalphax"; validate_str; continue ;;
142 TARGET) validate_target; continue ;;
143 esac
144
145
146 if [[ "${config_param}" = "LC_ALL" ]]; then
147 echo "`eval echo $PARAM_VALS`"
148 [[ -z "${!config_param}" ]] && echo -e "\nVariable LC_ALL cannot be empty!" && write_error_and_die
149 # See it the locale values exist on this machine
150 if [[ "`locale -a | grep -c ${!config_param}`" > 0 ]]; then
151 continue
152 else # If you make it this far then there is a problem
153 write_error_and_die
154 fi
155 fi
156
157 if [[ "${config_param}" = "LANG" ]]; then
158 echo "`eval echo $PARAM_VALS`"
159 [[ -z "${!config_param}" ]] && echo -e "\nVariable LANG cannot be empty!" && write_error_and_die
160 # See if the locale values exist on this machine
161 if [[ "`locale -a | grep -c ${!config_param}`" > 0 ]]; then
162 continue
163 else # If you make it this far then there is a problem
164 write_error_and_die
165 fi
166 fi
167
168
169 if [[ "${config_param}" = "KEYMAP" ]]; then
170 echo "`eval echo $PARAM_VALS`"
171 [[ "${!config_param}" = "none" ]] && continue
172 if [[ -e "/usr/share/kbd/keymaps/${!config_param}" ]] &&
173 [[ -s "/usr/share/kbd/keymaps/${!config_param}" ]]; then
174 continue
175 else
176 write_error_and_die
177 fi
178 fi
179
180 if [[ "${config_param}" = "SRC_ARCHIVE" ]]; then
181 echo -n "`eval echo $PARAM_VALS`"
182 if [ ! -z ${SRC_ARCHIVE} ]; then
183 if [ ! -d ${SRC_ARCHIVE} ]; then
184 echo " -- is NOT a directory"
185 write_error_and_die
186 fi
187 if [ ! -w ${SRC_ARCHIVE} ]; then
188 echo -n "${nl_} [${BOLD}${YELLOW}WARN$OFF] You do not have <write> access to this directory, ${nl_}${tab_}downloaded files can not be saved in this archive"
189 fi
190 fi
191 echo
192 continue
193 fi
194
195 if [[ "${config_param}" = "FSTAB" ]]; then
196 echo "`eval echo $PARAM_VALS`"
197 [[ -z "${!config_param}" ]] && continue
198 if [[ -e "${!config_param}" ]] &&
199 [[ -s "${!config_param}" ]]; then
200 continue
201 else
202 write_error_and_die
203 fi
204 fi
205
206 if [[ "${config_param}" = "BOOK" ]]; then
207 echo "`eval echo $PARAM_VALS`"
208 [[ ! "${WC}" = 1 ]] && continue
209 [[ -z "${!config_param}" ]] && continue
210 if [[ -e "${!config_param}" ]] &&
211 [[ -s "${!config_param}" ]]; then
212 continue
213 else
214 write_error_and_die
215 fi
216 fi
217
218 if [[ "${config_param}" = "CONFIG" ]]; then
219 echo "`eval echo $PARAM_VALS`"
220 [[ -z "${!config_param}" ]] && continue
221 if [[ -e "${!config_param}" ]] &&
222 [[ -s "${!config_param}" ]]; then
223 continue
224 else
225 write_error_and_die
226 fi
227 fi
228
229 if [[ "${config_param}" = "BOOT_CONFIG" ]]; then
230 if [[ "${METHOD}" = "boot" ]]; then
231 echo "`eval echo $PARAM_VALS`"
232 # There must be a config file when the build method is 'boot'
233 [[ -e "${!config_param}" ]] && [[ -s "${!config_param}" ]] && continue
234 # If you make it this far then there is a problem
235 write_error_and_die
236 fi
237 fi
238 done
239 done
240
241 set -e
242 echo "$tab_***${BOLD}${GREEN} ${PARAM_GROUP%%_*T} config parameters look good${OFF} ***"
243}
Note: See TracBrowser for help on using the repository browser.